<?php
include 'auth_check.php';
include 'config.php';

$data = json_decode(file_get_contents('php://input'), true);
$id = $data['id'];

$response = [];

if (!empty($id)) {
    $stmt = $conn->prepare("DELETE FROM rules WHERE id = ?");
    $stmt->bind_param("i", $id);

    if ($stmt->execute()) {
        $response['success'] = true;
    } else {
        $response['error'] = $stmt->error;
    }

    $stmt->close();
} else {
    $response['error'] = 'ID invalid.';
}

echo json_encode($response);
?>
