<?php
// Setările de conexiune la baza de date
$servername = "localhost";  // adresa serverului de baze de date, de obicei localhost
$username = "alexcele_x";     // numele de utilizator pentru baza de date
$password = "iBijoux22@@";     // parola pentru baza de date
$dbname = "alexcele_calculator";   // numele bazei de date

// Crearea conexiunii la baza de date
$conn = new mysqli($servername, $username, $password, $dbname);
$conn->set_charset("utf8");

// Verificarea conexiunii
if ($conn->connect_error) {
    die("Conexiunea a eșuat: " . $conn->connect_error);
}

function prepared_query($sql, $params = array(), $mysqli = null, $throw_500 = true)
{

    // Set default sql connector
    global $conn;
    if (!isset($mysqli)) {
        $mysqli = $conn;
    }

    $is_select_query = stripos(trim($sql), 'select') === 0;
    $is_insert_query = stripos(trim($sql), 'insert') === 0;

    $response = array();

    // prepare sql
    $stmt = $mysqli->prepare($sql);
    if (!$stmt) {

        $response[0][0] = 0;
        $response[0][1] = 'Eroare interna server. Va rugam sa incercati mai tarziu. 1';
        $response[0][2] = $mysqli->errno;

        // error log for debug
        error_log('SQL ERROR ' . $mysqli->errno . ': ' . $mysqli->error);
        error_log($sql);
        error_log('');

        if ($throw_500 && function_exists('API_output')) {
            API_output(
                array(
                    'code'    => 500,
                    'message' => 'Eroare interna server. Va rugam sa incercati mai tarziu.'
                )
            );
        }
        return $response;
    }


    // Automatically find parameter types and add it to $parameters
    if (count($params) > 0) {
        $parameter_types = '';
        foreach ($params as $index => $value) {
            if (is_numeric($value)) {
                if (is_int($value * 1)) {
                    $type = 'i';
                } else {
                    $type = 'd';
                }
            } else {
                $type = 's';
            }
            $parameter_types .= $type;
        }

        // Bind parameters
        $stmt->bind_param($parameter_types, ...$params);
    }
    if ($stmt->errno !== 0) {

        $response[0][0] = 0;
        $response[0][1] = 'Eroare interna server. Va rugam sa incercati mai tarziu. 2';
        $response[0][2] = $mysqli->errno;

        // error log for debug
        error_log('SQL ERROR ' . $mysqli->errno . ': ' . $mysqli->error);
        error_log($sql);
        error_log('');

        if ($throw_500 && function_exists('API_output')) {
            API_output(
                array(
                    'code'    => 500,
                    'message' => 'Eroare interna server. Va rugam sa incercati mai tarziu.'
                )
            );
        }
        return $response;
    }


    // execute query
    if (!$stmt->execute()) {
        $response[0][0] = 0;
        $response[0][1] = 'Eroare interna server. Va rugam sa incercati mai tarziu. 3';
        $response[0][2] = $mysqli->errno;

        // error log for debug
        error_log('SQL ERROR ' . $mysqli->errno . ': ' . $mysqli->error);
        error_log($sql);
        error_log('');

        if ($throw_500 && function_exists('API_output')) {
            API_output(
                array(
                    'code'    => 500,
                    'message' => 'Eroare interna server. Va rugam sa incercati mai tarziu.'
                )
            );
        }
        return $response;
    }

    $response[0][0] = 1;
    $response[0][1] = 'Query executed successfully';


    // save SELECT data
    if ($is_select_query) {

        $result = $stmt->get_result();

        $response[0][1] = $result->num_rows;

        // Extract and save results
        if ($response[0][1] > 0) {
            for ($i = 1; $i <= $response[0][1]; $i++) {
                $response[$i] = $result->fetch_assoc();
            }
        }

        $stmt->free_result();
    }

    // save INSERT data
    if ($is_insert_query) {
        $response[0][2] = $stmt->insert_id;
    }

    if (!$is_select_query) {
        // save affected rows
        $response[0][3] = $stmt->affected_rows;
    }
    $stmt->close();

    return $response;
}
function API_output($data){
    echo json_encode($data, JSON_PRETTY_PRINT);
    exit();
}
?>