<!DOCTYPE html>
<html lang="ro">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Listă Oferte</title>
    <link rel="stylesheet" href="css/detalii_lucrari.css">
</head>
<body>
<?php
include 'config.php'; // Conexiunea la baza de date

// Obține toate ofertele din baza de date
$sql = "SELECT id_oferta, nume_client, numar_telefon, email, obiectiv, data_oferta, numar_unic FROM oferta";
$result = $conn->query($sql);

// Verifică dacă există rezultate
if ($result->num_rows > 0) {
    echo "<div class='container'>";
    echo "<h2>Listă Oferte</h2>";
    echo "<p><a href='/deviziso/interfata.php'>Adauga oferta noua</a></p>";
    echo "<table class='styled-table'>
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Data</th>
                    <th>Nr. Deviz</th>
                    <th>Nume Client</th>
                    <th>Telefon</th>
                    <th>Email</th>
                    <th>Obiectiv</th>
                </tr>
            </thead>
            <tbody>";
    
    // Afișează fiecare ofertă
    while ($row = $result->fetch_assoc()) {
        echo "<tr>";
        echo "<td><a href='/deviziso/interfata.php?id_oferta={$row['id_oferta']}&load_page_using_offer_data=1'>{$row['id_oferta']}</a></td>";
        echo "<td>" . $row['data_oferta'] . "</td>";
        echo "<td>" . $row['numar_unic'] . "</td>";
        echo "<td>" . $row['nume_client'] . "</td>";
        echo "<td>" . $row['numar_telefon'] . "</td>";
        echo "<td>" . $row['email'] . "</td>";
        echo "<td>" . $row['obiectiv'] . "</td>";
        echo "</tr>";
    }
    echo "</tbody></table>";
    echo "</div>";
} else {
    echo "Nu există oferte în baza de date.";
}

$conn->close();
?>
</body>
</html>
